<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "practice_service".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PracticeService".
 *
 * Columns in table "practice_service" available as properties of the model,
 * followed by relations of table "practice_service" available as properties of the model.
 *
 * @property integer $id
 * @property integer $practice_id
 * @property string $description
 * @property integer $added_by_account_id
 * @property string $date_added
 * @property integer $updated_by_account_id
 * @property string $date_updated
 *
 * @property Account $addedByAccount
 * @property Practice $practice
 * @property Account $updatedByAccount
 */
abstract class BasePracticeService extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'practice_service';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PracticeService|PracticeServices', $n);
    }

    public static function representingColumn()
    {
        return 'description';
    }

    public function rules()
    {
        return array(
            array('practice_id, description, added_by_account_id, date_added', 'required'),
            array('practice_id, added_by_account_id, updated_by_account_id', 'numerical', 'integerOnly'=>true),
            array('description', 'length', 'max'=>255),
            array('date_updated', 'safe'),
            array('updated_by_account_id, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, practice_id, description, added_by_account_id, date_added, updated_by_account_id, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'updatedByAccount' => array(self::BELONGS_TO, 'Account', 'updated_by_account_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'practice_id' => null,
            'description' => Yii::t('app', 'Description'),
            'added_by_account_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'updated_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'addedByAccount' => null,
            'practice' => null,
            'updatedByAccount' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
